package utils.indicator;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

import core.Solution;

public class InvertedGenerationalDistancePlus {


	double invertedGenerationalDistance;
	ArrayList<Solution> pop = null;
	ArrayList<ArrayList<Double>> lambda;
	boolean maximize_ = true;



	public InvertedGenerationalDistancePlus(String fileName, ArrayList<Solution> pop, boolean maximize){
		lambda = new ArrayList<>();
		this.pop = pop;
		this.maximize_ = maximize;
		try {
			FileReader fr = new FileReader(fileName);
			BufferedReader br = new BufferedReader(fr);
			String temp;

			while((temp = br.readLine()) != null){
				String[] array = temp.split(",");
				ArrayList<Double> refPoint = new ArrayList<>();
				for(int j = 0; j < array.length; j++){
					refPoint.add(Double.parseDouble(array[j]));
				}
				lambda.add(refPoint);
			}
			br.close();
			fr.close();
		} catch (IOException e) {
			System.err.println(e);
		}
	}//Constructer


	public InvertedGenerationalDistancePlus(ArrayList<ArrayList<Double>> lambda, ArrayList<Solution> pop, boolean maximize){
		this.lambda = lambda;
		this.pop = pop;
		this.maximize_ = maximize;
	}//Constructer

	public double CalculateIGD(){
		this.invertedGenerationalDistance = 0.0;

		for(int i = 0, size = lambda.size(); i < size; i++){
			invertedGenerationalDistance += CalculateDistance(lambda.get(i),this.pop);
		}

		invertedGenerationalDistance /= lambda.size();

		return invertedGenerationalDistance;
	}

	public double CalculateDistance(ArrayList<Double> referencePoint, ArrayList<Solution> pop){

		double minDistance = Double.MAX_VALUE;
		double Distance;
		double value = 0.0;

		for(int i = 0, psize = pop.size(); i < psize; i++){
			Distance = 0.0;
			for(int j = 0, m = pop.get(i).getObjectives().length; j < m; j++){
				value = referencePoint.get(j) - pop.get(i).getObjective(j);
				if(!maximize_) value *= -1.0;
				Distance += Math.pow(Math.max(value, 0.0), 2);
			}//for
			Distance = Math.sqrt(Distance);
			if(Distance < minDistance){
				minDistance = Distance;
			}//if
		}//for
		return minDistance;
	}


	public double CalculateDistance(ArrayList<Double> referencePoint, Solution pop){

		double minDistance = Double.MAX_VALUE;
		double Distance;
		double value = 0.0;

			Distance = 0.0;
			for(int j = 0, m = pop.getObjectives().length; j < m; j++){
				value = referencePoint.get(j) - pop.getObjective(j);
				if(!maximize_) value *= -1.0;
				Distance += Math.pow(Math.max(value, 0.0), 2);
			}//for
			Distance = Math.sqrt(Distance);
			if(Distance < minDistance){
				minDistance = Distance;
			}//if
		return minDistance;
	}


	public static void main(String args[]) {

		String fileName = "";
		if(args.length%2 != 0) {
			System.err.println("the number of argument is an even number. ");
			System.exit(-1);
		} else {

		}



	}


}
